//+---------------------------------------------------------------------+
//|                                         BlauSMStochastic_Signal.mq5 | 
//|                                  Copyright  2014, Nikolay Kositsin | 
//|                                 Khabarovsk,   farria@mail.redcom.ru | 
//+---------------------------------------------------------------------+
//|     SmoothAlgorithms.mqh      |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2014, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description ""
//---   
#property version   "1.60"
//---     
#property indicator_separate_window
//---       
#property indicator_height 20
//---        
#property indicator_maximum +1.9
#property indicator_minimum +0.3
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0                           //        
#define INDTOTAL 1                        //     
#define INDICATOR_NAME "BlauSMStochastic" //    
//+----------------------------------------------+
//---   
#property indicator_buffers 4 // INDTOTAL*4
//---    
#property indicator_plots   2 // INDTOTAL*2
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//---   1   
#property indicator_type1   DRAW_COLOR_LINE
//---      
#property indicator_color1 clrOrangeRed,clrGold,clrGray,clrPaleGreen,clrGreen
//---   - 
#property indicator_style1  STYLE_SOLID
//---     2
#property indicator_width1  2
//---   
#property indicator_label1  "Signal line"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//---      
#property indicator_type2 DRAW_COLOR_ARROW
//---      
#property indicator_color2 clrOrangeRed,clrGold,clrGray,clrPaleGreen,clrGreen
//---   - 
#property indicator_style2 STYLE_SOLID
//---     5
#property indicator_width2 5
//---   
#property indicator_label2  "Signal Arrow"
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPL_,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  // TrendFollow_2 Price 
   PRICE_DEMARK_         // Demark Price 
  };
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Smooth_Method
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  };
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Mode
  {
   MODE_HISTOGRAM,  //  
   MODE_CLOUD       //  
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input ENUM_TIMEFRAMES TimeFrame=PERIOD_H4;   //  
input Mode Method=MODE_CLOUD;                //  
input Smooth_Method XMA_Method=MODE_EMA;     //  
input uint XLength=5;                        //   
input uint XLength1=20;                      //   
input uint XLength2=5;                       //   
input uint XLength3=3;                       //   
input uint XLength4=3;                       //    
input int XPhase=15;                         //  
//--- XPhase:  JJMA    -100 ... +100,     ;
//--- XPhase:  VIDIA   CMO,  AMA    
input Applied_price_ IPC=PRICE_CLOSE;        //  
//+----------------------------------------------+
//---      
int min_rates_total;
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
string GetStringTimeframe(ENUM_TIMEFRAMES timeframe)
  {return(StringSubstr(EnumToString(timeframe),7,-1));}
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+  
class CIndBuffers
  {
   //---
public:
   double            m_LineBuffer[];
   double            m_ColorLineBuffer[];
   double            m_ArrowBuffer[];
   double            m_ColorArrowBuffer[];
   int               m_Handle;
   ENUM_TIMEFRAMES   m_TimeFrame;
   //--- 
  };
//---   ,   
//---      
CIndBuffers Ind[INDTOTAL];
//+------------------------------------------------------------------+   
//| BlauSMStochastic indicator initialization function               | 
//+------------------------------------------------------------------+
bool IndInit(uint Number)
  {
//---     
   if(Ind[Number].m_TimeFrame<Period() && Ind[Number].m_TimeFrame!=PERIOD_CURRENT)
     {
      Print("IndInit(",Number,"):     BlauSMStochastic       ");
      return(false);
     }
//---     
   Ind[Number].m_Handle=iCustom(Symbol(),Ind[Number].m_TimeFrame,"BlauSMStochastic",
                            XMA_Method,XLength,XLength1,XLength2,XLength3,XLength4,XPhase,IPC);
   if(Ind[Number].m_Handle==INVALID_HANDLE)
     {
      Print("IndInit(",Number,"):      BlauSMStochastic");
      return(false);
     }
//---
   uint BIndex=Number*4+0;
   uint PIndex=Number*2+0;
   InitTsIndBuffer(BIndex,PIndex,Ind[Number].m_LineBuffer,EMPTY_VALUE,min_rates_total);
   InitTsIndColorBuffer(BIndex+1,Ind[Number].m_ColorLineBuffer);
   InitTsIndArrBuffer(BIndex+2,PIndex+1,Ind[Number].m_ArrowBuffer,EMPTY_VALUE,min_rates_total);
   InitTsIndColorBuffer(BIndex+3,Ind[Number].m_ColorArrowBuffer);
//---   
   string tmf=GetStringTimeframe(Ind[Number].m_TimeFrame);
   PlotIndexSetString(PIndex+0,PLOT_LABEL,INDICATOR_NAME+"Line("+tmf+")");
   PlotIndexSetString(PIndex+1,PLOT_LABEL,INDICATOR_NAME+"Arrow("+tmf+")");
//---    
   return(true);
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+  
void InitTsIndBuffer(uint Number,uint Plot,double &IndBuffer[],double Empty_Value,uint Draw_Begin)
  {
//---      
   SetIndexBuffer(Number,IndBuffer,INDICATOR_DATA);
//---      
   PlotIndexSetInteger(Plot,PLOT_DRAW_BEGIN,Draw_Begin);
//---   ,      
   PlotIndexSetDouble(Plot,PLOT_EMPTY_VALUE,Empty_Value);
//---       
   ArraySetAsSeries(IndBuffer,true);
//---
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+  
void InitTsIndArrBuffer(uint Number,uint Plot,double &IndBuffer[],double Empty_Value,uint Draw_Begin)
  {
//---      
   SetIndexBuffer(Number,IndBuffer,INDICATOR_DATA);
//---      
   PlotIndexSetInteger(Plot,PLOT_DRAW_BEGIN,Draw_Begin);
//---   ,      
   PlotIndexSetDouble(Plot,PLOT_EMPTY_VALUE,Empty_Value);
//---    
   PlotIndexSetInteger(Plot,PLOT_ARROW,159);
//---       
   ArraySetAsSeries(IndBuffer,true);
//---
  }
//+------------------------------------------------------------------+
//|                    |
//+------------------------------------------------------------------+  
void InitTsIndColorBuffer(uint Number,double &IndColorBuffer[])
  {
//---          
   SetIndexBuffer(Number,IndColorBuffer,INDICATOR_COLOR_INDEX);
//---       
   ArraySetAsSeries(IndColorBuffer,true);
//---
  }
//+------------------------------------------------------------------+ 
//| IndOnCalculate                                                   | 
//+------------------------------------------------------------------+ 
bool IndOnCalculate(int Number,int Limit,const datetime &Time[],uint Rates_Total,uint Prev_Calculated)
  {
//---   
   int limit_;
//---   
   datetime Time_[1],Time0;
   static int LastCountBar[INDTOTAL];
//---     
//---    limit    
   if(Prev_Calculated>Rates_Total || Prev_Calculated<=0)//      
     {
      limit_=Limit;
      LastCountBar[Number]=limit_;
     }
   else limit_=int(MathMin(LastCountBar[Number]+Limit,Rates_Total-2)); //      
//---    
   for(int bar=int(limit_); bar>=0 && !IsStopped(); bar--)
     {
      //---      
      Ind[Number].m_LineBuffer[bar]=Number+1.0;
      Ind[Number].m_ArrowBuffer[bar]=EMPTY_VALUE;
      Ind[Number].m_ColorLineBuffer[bar]=EMPTY_VALUE;

      Time0=Time[bar];
      //---      
      if(CopyTime(Symbol(),Ind[Number].m_TimeFrame,Time0,1,Time_)<=0) return(RESET);

      if(Time0>=Time_[0] && Time[bar+1]<Time_[0])
        {
         LastCountBar[Number]=bar;
         Ind[Number].m_ArrowBuffer[bar]=Number+1.0;
         Ind[Number].m_ColorLineBuffer[bar]=2;

         if(Method==MODE_CLOUD)
           {
            double Up[2],Dn[2];
            //---      
            if(CopyBuffer(Ind[Number].m_Handle,0,Time0,2,Up)<=0) return(RESET);
            if(CopyBuffer(Ind[Number].m_Handle,1,Time0,2,Dn)<=0) return(RESET);

            double diff1=Up[1]-Dn[1];
            double diff2=Up[0]-Dn[0];

            if(diff1>0)
              {
               if(diff2<=diff1)
                 {
                  Ind[Number].m_ColorLineBuffer[bar]=4;
                  Ind[Number].m_ColorArrowBuffer[bar]=4;
                 }
               else
                 {
                  Ind[Number].m_ColorLineBuffer[bar]=3;
                  Ind[Number].m_ColorArrowBuffer[bar]=3;
                 }
              }

            if(diff1<0)
              {
               if(diff2<=diff1)
                 {
                  Ind[Number].m_ColorLineBuffer[bar]=1;
                  Ind[Number].m_ColorArrowBuffer[bar]=1;
                 }
               else
                 {
                  Ind[Number].m_ColorLineBuffer[bar]=0;
                  Ind[Number].m_ColorArrowBuffer[bar]=0;
                 }
              }
           }

         if(Method==MODE_HISTOGRAM)
           {
            double Col[1];
            //---      
            if(CopyBuffer(Ind[Number].m_Handle,3,Time0,1,Col)<=0) return(RESET);
            Ind[Number].m_ColorLineBuffer[bar]=Col[0];
            Ind[Number].m_ColorArrowBuffer[bar]=Col[0];
           }
        }
      if(Ind[Number].m_ColorLineBuffer[bar+1]!=EMPTY_VALUE && Ind[Number].m_ColorLineBuffer[bar]==EMPTY_VALUE)
        {
         Ind[Number].m_ColorLineBuffer[bar]=Ind[Number].m_ColorLineBuffer[bar+1];
        }
     }
//---        
   return(true);
  }
//+------------------------------------------------------------------+   
//| BlauSMStochastic indicator initialization function               | 
//+------------------------------------------------------------------+ 
int OnInit()
  {
//---     
   min_rates_total=3;
//---   
   Ind[0].m_TimeFrame=TimeFrame;
//---   
   for(int count=0; count<INDTOTAL; count++) if(!IndInit(count)) return(INIT_FAILED);
   string word;
   if(Method==MODE_CLOUD) word="Cloud, ";
   else word="Histogram, ";
   word=word+GetStringTimeframe(Ind[0].m_TimeFrame);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"BlauSMStochastic("+word+")");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+ 
//| BlauSMStochastic iteration function                              | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(RESET);
   for(int count=0; count<INDTOTAL; count++)
      if(BarsCalculated(Ind[count].m_Handle)<Bars(Symbol(),Ind[count].m_TimeFrame))
         return(prev_calculated);
//---   
   int limit;
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-min_rates_total-1; //      
   else limit=rates_total-prev_calculated; //       
//---         
   ArraySetAsSeries(time,true);
   for(int count=0; count<INDTOTAL; count++) if(!IndOnCalculate(count,limit,time,rates_total,prev_calculated)) return(RESET);
//---   
   return(rates_total);
  }
//+------------------------------------------------------------------+

   